class DietaDSL < Diet
	attr_accessor :titulos, :ingestas, :platos, :porcentajes, :salida

	def initialize(name,&block)
		self.titulos=[]
		self.ingestas=[]
		self.platos=[]
		self.porcentajes=[]

		if block_given?
			if block.arity ==1
				yield self
			else
				instance_eval(&block)
			end
		end
	end

	def titulo(name)
		titulos << name
	end

	def ingesta(opciones ={})
		ingestas << "#{opciones[:min]}" if opciones[:min]
		ingestas << "#{opciones[:max]}" if opciones[:max]
	end

	def plato(opciones= {})
		platos << "#{opciones[:descripcion]}" if opciones[:descripcion]
		platos << "#{opciones[:porcion]}" if opciones[:porcion]
		platos << "#{opciones[:gramos]}" if opciones[:gramos]
	end

	def porcentaje(opciones={})
		porcentajes << "#{opciones[:vct]}" if opciones[:vct]
		porcentajes << "#{opciones[:proteinas]}" if opciones[:proteinas]
		porcentajes << "#{opciones[:grasas]}" if opciones[:grasas]
		porcentajes << "#{opciones[:hidratos]}" if opciones[:hidratos]
	end

	def to_s
		salida = titulos
		        salida << "(#{ingestas[0]}% - #{ingestas[1]}%)"
		        platos.each_with_index do |plato|
		            salida << "#{plato}"
		        end
		        salida << "V.C.T. | % #{porcentajes[0]} Kcal | #{porcentajes[1]}% - #{porcentajes[2]}% - #{porcentajes[3]}%"
		        salida
	end
end
